clear

load fisheriris
X = meas';
[D,N] = size(X);

K = 3;
trueLabels = zeros(N,1);
for ii = 1:N
    if strcmp(species{ii},'setosa')
        trueLabels(ii) = 1;
    elseif strcmp(species{ii},'versicolor')
        trueLabels(ii) = 2;
    else
        trueLabels(ii) = 3;
    end
end

%% K-means
estLabels = kmeans(X',K,'Replicates',100);
kmeansErr = missRate(trueLabels,estLabels)

%% Spectral clustering
nNeighbors = N - 5;
type = 'gaussian';
sigma = 0.5;
W = myKNN(X,nNeighbors,type,sigma);

% apply spectral clustering
[estLabels,Y] = mySpectralClustering(W,K,0);
scErrUn = missRate(trueLabels,estLabels)

[estLabels,Y] = mySpectralClustering(W,K,1);
scErr = missRate(trueLabels,estLabels)
